using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerBehaviour : MonoBehaviour
{
    public Transform leftFoot, rightFoot;
    public Vector3 footOffset,footRotation;
    public LayerMask layerMask;
    private Animator animator;
    
    // Start is called before the first frame update
    void Start()
    {
        animator = GetComponent<Animator>();
    }

    // Update is called once per frame
    void Update()
    {        
        animator.SetFloat("WalkSpeed", Input.GetAxis("Vertical") * ( Input.GetKey(KeyCode.LeftShift) ? 1.0f : 0.49f ) );
        
        animator.SetFloat("Turn", Input.GetAxis("Horizontal"));

        if (Input.GetButtonDown("Jump"))
        {
            animator.SetTrigger("Kick");
        }

    }

    void HandleIKFoot(Transform foot, AvatarIKGoal goal)
    {
        RaycastHit hitInfo;

        Debug.DrawLine(foot.transform.position+Vector3.up*0.5f,foot.transform.position,Color.red);

        if (Physics.Raycast(foot.transform.position+Vector3.up*0.5f,Vector3.down,out hitInfo,0.51f,layerMask))
        {
            animator.SetIKPosition(goal,hitInfo.point+footOffset);
            animator.SetIKRotation(goal,Quaternion.LookRotation(hitInfo.normal,transform.forward) * Quaternion.Euler(footRotation));
            animator.SetIKPositionWeight(goal,1);
            animator.SetIKRotationWeight(goal,1);
        } else
        {
            animator.SetIKPositionWeight(goal,0);
            animator.SetIKRotationWeight(goal,0);
        }
    }

    void OnAnimatorIK()
    {
        HandleIKFoot(leftFoot,AvatarIKGoal.LeftFoot);
        HandleIKFoot(rightFoot,AvatarIKGoal.RightFoot);
	}
}
